'**************************************
'
' C-Control/BASIC Multi64.BAS
'
' Aufgabe:
'
' - Multiplexer mit 8 x 4051
' - Messen der Kanle 0..63
' -
'
'**************************************

' --- Definitionen --------------------
define Analog1 AD[1]
define PA Port[1]
define PB Port[2]
define PC Port[3]
define Inhibit Byteport[2]
define Kanal Byte
define Adresse Byte
define IcNr Byte
define Messwert Byte

print "Multi64.bas"
' --- Programmoperationen -------------
#Loop
Inhibit = &B11111111
PA=0: PB=0:PC=0
for Kanal = 0 to 63
gosub Messung
print Kanal, Messwert 'messen und senden
pause 25 '0,5 s warten
next Kanal
goto Loop 'Endlosschleife
end

#Messung
IcNr = Kanal / 8
Adresse = Kanal mod 8
If IcNr = 0 then Inhibit = &B11111110
If IcNr = 1 then Inhibit = &B11111101
If IcNr = 2 then Inhibit = &B11111011
If IcNr = 3 then Inhibit = &B11110111
If IcNr = 4 then Inhibit = &B11101111
If IcNr = 5 then Inhibit = &B11011111
If IcNr = 6 then Inhibit = &B10111111
If IcNr = 7 then Inhibit = &B01111111
PA = (Adresse and 1)
PB = (Adresse and 2)/2
PC = (Adresse and 4)/4
pause 1
Messwert = Analog1 'messen
return