; RC5-Unterprogramm RC5.asm    (Dieses Programm ist unter dem Dateinamen 'RC5.tasm' auch fuer den Assembler 'TASM' vorhanden.)
; nach einer Vorlage von Olaf Kaluza
PC           equ $02
Cnt          equ $0A1
Kon          equ $0A2
Adr          equ $0A3
Tas          equ $0A4
             
             org $101
             
             Clr Kon
             Clr Adr
             Clr Tas
rc5          brset 0,PC,rc5 ;Warten auf Startbit
             jsr w444 ;warten
             brset 0,PC,rc5 ;Stoerimpuls
             jsr w444 ;Naechsten Biphasenpegel
             jsr w444
             brclr 0,PC,rc5 ;Stoerimpuls
             jsr w444
             jsr w444
             brset 0,PC,rc5 ;Stoerimpuls
             jsr w444 ;Ok weiter
             jsr w444 ;Kontrollbit einlesen
             jsr getbit ;Kontrollbit hier im Carry
             rol Kon
             ldx #5 ;5 Adressbits
rcadr        jsr w444
             jsr w444
             jsr getbit
             rol Adr ;Bit merken
             decx
             bne rcadr
             ldx #6 ;6 Datenbits
rcdat        jsr w444
             jsr w444
             jsr getbit
             rol Tas ;merken
             decx
             bne rcdat
             rts ;Zurueck zum Hauptprogramm

;---------------------------------------------------
;Einlesen eines Bits, Rueckgabe in Carry

getbit       lda #255 ;Timeout festlegen
             sta Cnt
             brset 0,PC,gethi ;Wird es ein Lowbit?
gbl1         brset 0,PC,gbl2 ;Auf Biphasensprung synchronisieren
             dec Cnt
             bne gbl1
             bra biterr ;Timeout
gbl2         jsr w444
             brclr 0,PC,biterr ;Fehler
             clc ;Lowbit
             rts

gethi        brclr 0,PC,gethi2 ;auf Phasensprung synchronisieren
             dec Cnt
             bne gethi
             bra biterr ;Timeout
gethi2       jsr w444
             brset 0,PC,biterr ;Fehler?
             sec ;Highbit
             rts

biterr       Clr Kon ;Fehler, alles lschen
             clr Adr
             clr Tas
             clr Cnt
             rts
;--------------------------------------------------
; Warteroutine fuer 1/4 eine Biphasenbits = 444us = 444T bei 12Mhz
; ;Aufrufcall 2T
w444         lda #147 ; 3
loop         deca ; 3 A -1
             bne loop ; 3 6*0,5s = 3/Schleife
             rts
END