'**************************************
'
' C-Control/BASIC DS1820_2.BAS
'
' Aufgabe:
'
' - Temperaturmessung mit DS1820
' - Datenlogger
'
'**************************************

' --- Definitionen --------------------
define bas_1 byte
define bas_2 byte
define bas_3 byte
define Temp_lo byte
define temp_hi byte
define temp word
define Kommando byte

print "DS1820_2.bas"
' --- Programmoperationen -------------
print "testprogramm ds1820_2.bas"
#Anfang
open# for write
#Loop2
gosub Messung
gosub Warten
goto Loop2
end
#Messung
gosub messen
if (fileFree > 10) then print# Temp
return
#Warten
if rxd then gosub Unterbrechung
if Second > 0 then goto Warten
#Warten2
if rxd then gosub Unterbrechung
if Second = 0 then goto Warten2
return
#Unterbrechung
get Kommando
if Kommando = 27 then gosub Auslesen
return
#Auslesen
close#
open# for read
#Next
input# Temp
print Temp
if not EOF then goto Next
close#
open# for append
return
#messen bas_2 = &HCC ' Reset & "Skip-Rom"
sys &H0101 ' Sprung in Assembler
pause 1
bas_2 = &H44 ' "Convert-Temp" Kommando
sys &H0120 ' Kommando senden
pause 1
#loop pause 20 ' 0.5 s warten
sys &H0146 ' read DS1820
if bas_2 = 0 then goto loop ' busy?
bas_2 = &HCC ' Reset & "Skip-Rom"
sys &H0101 ' Kommando senden
pause 1
bas_2 = &HBE ' "Read-Scratchpad"
sys &H0120 ' Kommando senden
pause 1
sys &H0146 ' 1 Byte lesen
temp_lo = bas_2
sys &H0146 ' 1 Bytes lesen
temp_hi = bas_2
pause 1
temp = (10*temp_lo)/2
if temp_hi <> 0 then temp = 2560-(10*temp_lo)/2
print temp
return

'syscode "ds1820" 'Diesen Code laden, wenn der Assembler 'TASM' verwendet wird.
 '(oder)
syscode "ds1820.s19" 'Diesen Code laden, wenn der Assembler 'AS05' oder als IDE  'die |_ Distribution'  verwendet wird.