'**************************************
'
' C-Control/BASIC DS1820_3.BAS
'
' Aufgabe:
'
' - Temperaturmessung mit DS1820
' - Temperatur-Regelkreis
'
'**************************************
' --- Definitionen --------------------
define bas_1 byte
define bas_2 byte
define bas_3 byte
define Temp_lo byte
define temp_hi byte
define temp word
define Soll 270
define Relais Port[2]

print "DS1820_3.bas"
' --- Programmoperationen -------------
print "testprogramm ds1820_3.bas"
#main bas_2 = &HCC ' Reset & "Skip-Rom"
sys &H0101 ' Sprung in Assembler
pause 1
bas_2 = &H44 ' "Convert-Temp" Kommando
sys &H0120 ' Kommando senden
pause 1
#loop pause 20 ' 0.5 s warten
sys &H0146 ' read DS1820
if bas_2 = 0 then goto loop ' busy?
bas_2 = &HCC ' Reset & "Skip-Rom"
sys &H0101 ' Kommando senden
pause 1
bas_2 = &HBE ' "Read-Scratchpad"
sys &H0120 ' Kommando senden
pause 1
sys &H0146 ' 1 Byte lesen
temp_lo = bas_2
sys &H0146 ' 1 Bytes lesen
temp_hi = bas_2
pause 1
temp = (10*temp_lo)/2
if temp_hi <> 0 then temp = 2560-(10*temp_lo)/2
print temp,
if Temp > Soll then Relais = OFF
if Temp < Soll then Relais = ON
goto main
end

'syscode "ds1820" 'Diesen Code laden, wenn der Assembler 'TASM' verwendet wird.
 '(oder)
syscode "ds1820.s19" 'Diesen Code laden, wenn der Assembler 'AS05' oder als IDE  'die |_ Distribution'  verwendet wird.