;Wahlfreier Zugriff auf ein EEPROM: EEIO.ASM
;(Dieses Programm ist unter dem Dateinamen 'EEIO.tasm' auch fuer den Assembler 'TASM' vorhanden.)
AdrI2C  equ $A1     ;bergabe Busadresse
Dat     equ $A2     ;Daten in/out
AdrHi   equ $A3     ;interne Adresse
AdrLo   equ $A4     ;als Word

        org $101
;Einsprung $101, Daten schreiben
;CC-EEPROM vom Bus abmelden
        jsr $08BB    ;I2C_ReadLast
;Byte in eigenes EEPROM schreiben
        ldx AdrI2C   ;I2C-Adresse
        jsr $083C    ;I2C_Start
        ldx AdrHi    ;Adr High
        jsr $0846    ;I2C_Write
        ldx AdrLo    ;Adr low
        jsr $0846    ;I2C_Write
        ldx Dat      ;Daten
        jsr $0846    ;I2C_Write
        jsr $08E5    ;I2C_Stop
;CC-EEPROM wieder anmelden
        ldx #$0A0    ;Adresse 24C65, write
        jsr $083C    ;I2C_Start
        ldx $066     ;AdrCounter Hi
        jsr $0846    ;I2C_Write
        ldx $067     ;AdrCounter Lo
        jsr $0846    ;I2C_Write
        ldx #$0A1    ;Adresse 24C65, read
        jsr $083C    ;I2C_Start
        rts

;Einsprung $130, Daten lesen 
;CC-EEPROM vom Bus abmelden
        jsr $08BB    ;I2C_ReadLast
;Byte aus eigenem EEPROM lesen
        ldx AdrI2C   ;I2C-Adresse
        jsr $083C    ;I2C_Start
        ldx AdrHi    ;Adr High
        jsr $0846    ;I2C_Write
        ldx AdrLo    ;Adr low
        jsr $0846    ;I2C_Write
        ldx $0A1     ;I2C-Adresse
        incx         ;Adr+1, Lesen
        jsr $083C    ;I2C_Start
        jsr $086F    ;I2C_Read
        sta Dat      ;Daten speichern
        jsr $08BB    ;I2C_ReadLast
;CC-EEPROM wieder anmelden
        ldx #$0A0    ;Adresse 24C65, write
        jsr $083C    ;I2C_Start
        ldx $066     ;AdrCounter Hi
        jsr $0846    ;I2C_Write
        ldx $067     ;AdrCounter Lo
        jsr $0846    ;I2C_Write
        ldx #$0A1    ;Adresse 24C65, read
        jsr $083C    ;I2C_Start
        rts
.end
